; Safe-T-Calc v2.1
; Ash 3.0 + or Crash 1.1+
; by Don Barnes & John McCord
; Latest Release- March 12, 1999

#INCLUDE "ti82.h"
#INCLUDE "oldcall.h"

.org START_ADDR
.db "Safe-T-Calc",0

flag = TEXT_MEM

main:
	ROM_CALL(CLEARLCD)	; Clear screen
	sub	a		; Set 1 to a
	ld	($800c),a	; Set cursor row to 1
	ld	($800d),a	; Set cursor column to 1
	set	3,(IY+05)	; Inverses pixel color
     	LD HL,safe		; Point HL at string
     	ROM_CALL(D_ZT_STR)	; Call ROMCALL
	res	3,(IY+05)	; Inverses pixel color
	sub	a		; Set 1 to a
	ld	($800d),a	; Set cursor column to 1
	ld	a,1		; Set 2 to a
	ld	($800c),a	; Set cursor row to 2
     	LD HL,options		; Load string at label "options"
     	ROM_CALL(D_ZT_STR)	; Call ROMCALL

mlop
	CALL GET_KEY		; Check for keypress
	CP	34		; Was 1 pressed?
	JUMP_Z(lock)		; If yes, go to label "lock"
	CP	26		; Was 2 pressed?
	JUMP_Z(newpass)		; If yes, go to label "newpass"
	CP	$37		; Was mode pressed?
	JUMP_Z(quit)		; If yes, go to label "quit"
	jr	mlop		; If no, go to beginning of loop

quit
	RET			; Return to shell

lock
	ROM_CALL(CLEARLCD)	; Clear screen
	CALL $07EA		; Power down
	sub	a		; Set 1 to a
	ld	($800d),a	; Set cursor column to 1
	ld	($800c),a	; Set cursor row to 1
     	LD HL,login		; Load string at label "login"
     	ROM_CALL(D_ZT_STR)	; Call ROMCALL
	CALL_(check)		; Call label "check" to check pass
	ld	a,(flag)	; Compare entered pass to stored pass
	cp	0		; Do they match?
	JUMP_NZ(lock)		; If no, goto label "lock"
	JUMP_(quit)		; If yes, goto label "quit"
	
newpass
	ROM_CALL(CLEARLCD)	; Clear screen
	sub	a		; Set 1 to a
	ld	($800d),a	; Set cursor column to 1
	ld	($800c),a	; Set cursor row to 1
     	LD HL,oldpass		; Load string at label "oldpass"
     	ROM_CALL(D_ZT_STR)	; Call ROMCALL
	CALL_(check)		; Call label "check" to check pass
	ld	a,(flag)	; Compare entered pass to stored pass
	cp	0		; Do they match?
	JUMP_NZ(main)		; If no, goto label "main"
	sub	a		; Set 1 to a
	ld	($800d),a	; Set cursor column to 1
	ld	a,2		; Set 3 to a
	ld	($800c),a	; Set cursor row to 3
     	LD HL,newspass		; Load string at label "newpass"
     	ROM_CALL(D_ZT_STR)	; Call ROMCALL
	ld	hl,pass		; Save string as password

newloop
	push	hl		; Save hl
	CALL GET_KEY		; Wait on a keypress
	pop	hl		; Remember hl
	cp	0		; Does getkey match hl
	jr	z,newloop	; If no, goto start of loop
	ld	(hl),a		; Compare hl to a
	CP	9		; Do they match?
	jr	z,endnew	; If yes, goto end of loop
	push	hl		; Save hl
     	LD HL,star		; Load string at label "star"
     	ROM_CALL(D_ZT_STR)	; Call ROMCALL
	ld	bc,1		; (bc is current character)
	pop	hl		; Remember hl
	add	HL,bc		; Add bc to hl (hl is pass entered so far)
	ld	a,(hl)		; Compare a to hl
	CP	255		; Was it the correct password?
	jr	nz,newloop	; If no, go to start of loop

endnew
	JUMP_(main)		; Goto label "main"

check
	ld	a,0		; Load 1 to a
	ld	(flag),a
	ld	hl,pass

checkloop
	push	hl		; Save hl
	CALL GET_KEY		; Wait for keypress
	pop	hl		; Remember hl
	cp	0		; If statement
	jr	z,checkloop	; If conditions met, goto start of loop
	ld	b,(hl)		; Compare b to hl
	cp	b		; If statement
	jr	z,noflag	; If conditions met, goto label "noflag"
	ld	d,a		; Load a to d
	ld	a,1		; Load 1 to a
	ld	(flag),a	: Load a to flag
	ld	a,d		; Load d to a

noflag
	CP	9		; Does entered pass match pass
	jr	z,endpass	; If yes, goto label "endpass"
	push	hl		; Save hl
     	LD HL,star		; Load string at label "star"
     	ROM_CALL(D_ZT_STR)	; Call ROMCALL
	ld	bc,1		; Load 1 to bc
	pop	hl		; Remember hl
	add	HL,bc		; Add bc to hl
	ld	a,(hl)		; Compare a to hl
	CP	255		; Was it the correct password?
	jr	nz,checkloop	; If no, goto label checkloop

endpass
	ret			; Return to shell

safe
	.db	"Safe-T-Calc v2.1",0
options
	.db	"1. Shut Down    "
	.db	"2. New Pass",0
oldpass
	.db	"Old password:   ",0
newspass
	.db	"New password:   ",0
login 
	.db	"Password:",0
star
	.db	"*",0
pass
	.db	9,9,9,9,9,9,9,9,255,0
.END
.END
.END
.END
